/* $Id: analyze.c,v 1.1 1996/11/07 08:04:58 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	̓W[
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include <stdio.h>
#include <string.h>

#include "disasm.h"
#include "estruct.h"
#include "etc.h"	/* charout */
#include "global.h"
#include "label.h"	/* regist_label etc. */
#include "offset.h"	/* depend_address , nearadrs */
#include "analyze.h"


USEOPTION	option_i;

boolean		Reason_verbose;


/* private ֐vg^Cv */
private address limitadrs( address );
private boolean branch_job( address, address, address, address,
			    analyze_mode, address );
private void	regist_data( disasm* , operand* );
private boolean	prolabel( address );
private void	pcix( address , address );
private void	unregist_data( operand* );


/*
	right_opecode().
	AhXɈˑ\ȃIyhˑĂ
	neardepend̈ˑAhXɐi߂.
	ˑs\AˑĂȂ΂̂܂.
*/
INLINE
private address skip_depend_ea( address neardepend ,
				disasm *code , operand *op )
{
    switch( op->ea ) {
	case AbLong:
	    if( neardepend == op->eaadrs )
		neardepend = nearadrs( neardepend + 1 );
	    break;
	case IMMED:
	    if( neardepend == op->eaadrs && code->size == LONGSIZE )
		neardepend = nearadrs( neardepend + 1 );
	    break;
	case AregIDXB:
	    if( neardepend == op->eaadrs && op->exbd == 4 )
		neardepend = nearadrs( neardepend + 1 );
	    break;
	case AregPOSTIDX:
	case AregPREIDX:
	    if( neardepend == op->eaadrs && op->exbd == 4 )
		neardepend = nearadrs( neardepend + 1 );
	case PCPOSTIDX:
	case PCPREIDX:
	    if( neardepend == op->eaadrs2 && op->exod == 4 )
		neardepend = nearadrs( neardepend + 1 );
	    break;
	default:
	    break;
    }
    return neardepend;
}

/*

  right opecode ?

*/
INLINE
private boolean right_opecode( address neardepend , disasm *code , address pc )
{
    if( pc <= neardepend )
	return TRUE;

    neardepend = skip_depend_ea( neardepend , code , &code->op1 );
    neardepend = skip_depend_ea( neardepend , code , &code->op2 );
    neardepend = skip_depend_ea( neardepend , code , &code->op3 );
    neardepend = skip_depend_ea( neardepend , code , &code->op4 );

#ifdef DEBUG
    if( !(pc <= neardepend) && ( Debug & BREASON ) )
	printf( "right opecode failed\n" );
#endif
    return (pc <= neardepend);
}


/*

  ͂

  input:
    start : analyze start address
    mode  : ANALYZE_IGNOREFAULT
	    ł̖`ߓ𖳎
	    ANALYZE_NORMAL
	    Ŗ`ߓtAĂяo̓f[^̈
  return:
    FALSE : pc ̓vÖƔF߂Ȃ

*/
#define TRUEret		goto trueret
#define FALSEret	goto falseret
#define ROUTINE_END( pc )	ch_lblmod( pc , DATLABEL | UNKNOWN )

extern boolean	analyze( address start , analyze_mode mode )
{
    address	previous_opval , previous_pc;
    address	pc = start , store = start + Ofst;
    address	limit;
    address	neardepend;
    disasm	code;
    int		orib = 0;	/* ori.b #??,d0 = $0000???? */

#ifdef DEBUG
    if( Debug & ( BDEBUG | BREASON ) )
	printf( "an %x(%d)\n" , start , mode );
#endif
    charout( '>' );

    if( Available_text_end <= pc ) {
	if( Reason_verbose )
	    eprintf( "\n%06x : PC LȃZNVOꂽ\t" , pc );
	FALSEret;
    } else if( depend_address( pc ) || depend_address( pc - 2 ) ) {
	if( Reason_verbose )
	    eprintf( "\n%06x : PC AhXɈˑĂ\t" , pc );
	FALSEret;
    } else if( (ULONG)pc & 1 ) {
	if( Reason_verbose )
	    eprintf( "\n%06x : PC \t" , pc );
	FALSEret;
    } else if( ((ULONG)pc & 1 ) != 0 || *(LONG*)store == 0 ) {
	if( Reason_verbose )
	    eprintf( "\n%06x : PC  ori.b #0,d0 n܂Ă\t" , pc );
	FALSEret;
    }

    /* the follow 4 lines are omitable , maybe */
#if 0
    if( prolabel( start ) ) {
	regist_label( start , PROLABEL );
	TRUEret;
    }
#endif
    limit = limitadrs( pc );
    neardepend = nearadrs( pc );
    if( !regist_label( start , PROLABEL ) ) {		/*  ch_lblmod ł͑ʖ */
#ifdef DEBUG
	if( Debug & BDEBUG )
	    printf( "%x cannot be prolabel\n" , pc );
#endif
	TRUEret;
    }

    PCEND = Available_text_end;

    while(1) {
	if( neardepend == pc ) {			/* AhXˑ`FbN */
	    not_program( start , (address)min( (ULONG)pc , (ULONG)limit ) );
	    if( Reason_verbose )
		eprintf( "\n%06x : PC AhXɈˑĂ\t" , pc );
	    FALSEret;
	}

	if( *(UWORD*)store == 0 ) {			/* ori.b #??,d0 `FbN */
	    if( orib++ >= 2 || *(UWORD*)( store + 2 ) == 0 ) {
		not_program( start , (address)min( (ULONG)pc , (ULONG)limit ) );
		if( Reason_verbose )
		    eprintf( "\n%06x : ori.b #??,d0 AĂA"
			    "܂ ori.b #0,d0 𔭌\t" , pc );
		FALSEret;
	    }
	} else
	    orib = 0;

	if( limit == pc && prolabel( limit ) ) {	/* ɉ͍ς݂̗̈ƂԂH */
#ifdef DEBUG
	    if( Debug & BDEBUG )
		printf( "Already\n" );
#endif
	    ROUTINE_END( pc );
	    TRUEret;
	}

	if( (pc > limit) ||	/* ŏ code.op.opval ͏ȂǑv */
	    (pc <= code.op1.opval && code.op1.opval < limit) ||
	    (pc <= code.op2.opval && code.op2.opval < limit) ||
	    (pc <= code.op3.opval && code.op3.opval < limit) ||
	    (pc <= code.op4.opval && code.op4.opval < limit) )
	    limit = limitadrs( pc );

	previous_opval = ( code.op1.ea == PCIDX ? code.op1.opval : (address)-1 );
	previous_pc = pc;
	store += dis( store , &code , &pc );

#ifdef DEBUG
	if( Debug & BTRACE ) {
	    static char *size[ 10 ] = {
		".b" , ".w" , ".l" , ".q" , ".s" , ".s" , ".d" , ".x" , ".p" , "" ,
	    };

	    printf( "%05x:%05x\t" , previous_pc , limit );
	    if( code.op4.operand[ 0 ] ){
		printf( "%s%s\t%s,%s,%s,%s\n" , code.opecode , size[code.size] ,
			code.op1.operand , code.op2.operand ,
			code.op3.operand , code.op4.operand );
	    }else if( code.op3.operand[ 0 ] ){
		printf( "%s%s\t%s,%s,%s\n" , code.opecode , size[code.size] ,
			code.op1.operand , code.op2.operand ,
			code.op3.operand );
	    }else if( code.op2.operand[ 0 ] ){
		printf( "%s%s\t%s,%s\n" , code.opecode , size[code.size] ,
			code.op1.operand , code.op2.operand );
	    }else if( code.op1.operand[ 0 ] ){
		printf( "%s%s\t%s\n" , code.opecode , size[code.size] , code.op1.operand );
	    }else{
		printf( "%s%s\n" , code.opecode , size[code.size] );
	    }
	}
#endif
	/* add '90 Sep 24 */
	if( Available_text_end < pc ) {
	    if( Reason_verbose )
		eprintf( "\n%06x : PC LȃZNVOꂽ\t" , pc );
	    not_program( start , (address)min( (ULONG)previous_pc , (ULONG)limit ) );
	    FALSEret;
	}
	if( neardepend < pc ) {
#ifdef DEBUG
	    if( Debug & BDEBUG ) {
		printf( "over neardepend:%x\n" , pc );
		printf( "size %d ea1 %d ea2 %d ea3 %d ea4 %d"
			"op1val %x op2val %x op3val %x op4val %x"
			"ea1adrs %x ea2adrs %x ea3adrs %x ea4adrs %s"
			"\n" ,
			code.size , code.op1.ea , code.op2.ea , code.op3.ea , code.op4.ea ,
			code.op1.opval , code.op2.opval , code.op3.opval , code.op4.opval ,
			code.op1.eaadrs , code.op2.eaadrs , code.op3.eaadrs , code.op4.eaadrs
			);
	    }
#endif
	    if( right_opecode( neardepend , &code , pc ) )
		neardepend = nearadrs( pc );
	    else {
		if( Reason_verbose )
		    eprintf( "\n%06x : AhXˑ̃IyhłȂ\t" , previous_pc );
		not_program( start , (address)min( (ULONG)previous_pc , (ULONG)limit ) );
		FALSEret;
	    }
	}

	switch( code.flag ) {
	case UNDEF:
	    if( Reason_verbose )
		eprintf( "\n%06x : `(%04x %04x)\t" , previous_pc ,
		       *(UWORD*)( previous_pc + Ofst ) , *(UWORD*)( previous_pc + Ofst + 2 ) );
	    not_program( start , (address)min( (ULONG)previous_pc , (ULONG)limit ) );
	    FALSEret;
	case OTHER:
	    regist_data( &code , &code.op1 );
	    regist_data( &code , &code.op2 );
	    regist_data( &code , &code.op3 );
	    regist_data( &code , &code.op4 );
	    break;
	case JMPOP:
	    if( ! ( code.jmp == (address)-1 ||
		  ( code.op1.ea == AbLong && !INPROG( code.jmp , code.op1.eaadrs ) ) ) ) {
		if( code.op1.ea == PCIDX )
		    pcix( code.jmp , previous_opval );
		else
		    if( !branch_job( code.jmp, start, pc, previous_pc, mode, limit ) )
			FALSEret;
	    }
	case RTSOP:
	    ROUTINE_END( pc );
	    TRUEret;
	case JSROP:
	    if( ! ( code.jmp == (address)-1 ||
		  ( code.op1.ea == AbLong && !INPROG( code.jmp , code.op1.eaadrs ) ) ||
		    code.op1.ea == AbShort ) ) {
		if( code.op1.ea == PCIDX )
		    pcix( code.jmp , previous_opval );
		else
		    if( !branch_job( code.jmp, start, pc, previous_pc, mode, limit ) )
			FALSEret;
	    }
	    break;
	case BCCOP:
	    if( !branch_job( code.jmp, start, pc, previous_pc, mode, limit ) )
		FALSEret;
	    break;
	}
    }

    return( TRUE );			/* not reached absolutely */

 falseret:
    charout( '?' );
    ch_lblmod( start , DATLABEL | UNKNOWN | FORCE );
    return( FALSE );
 trueret:
    charout( '<' );
#ifdef DEBUG
    if( Debug & BDEBUG )
	printf("ret\n");
#endif
    return( TRUE );
}


/*

  adrs ̃f[^x̃AhXԂ
  ̂悤ȃx Available_text_end Ԃ

*/
private address limitadrs( address adrs )
{
    lblbuf	*lptr;

#ifdef DEBUG
    if( Debug & BDEBUG )
	printf( "lmt(%x)=" , adrs );
#endif
    lptr = next( adrs + 1 );
#if 0
    if( lptr->label == adrs && isDATLABEL( lptr->mode ) ) {
	ch_lblmod( adrs , PROLABEL );
	return limitadrs( adrs + 1 );		/*  +1 ͉̂̂? */
    }
#endif /* 0 */
#ifdef DEBUG
    if( Debug & BDEBUG )
	printf( "%x\n" , lptr->label );
#endif

    return (address)min( (ULONG)lptr->label , (ULONG)Available_text_end );
}


/*

  򖽗ߓ̏

*/
private boolean branch_job( address opval , address start , address pc , address pre_pc
			, analyze_mode mode , address limit )
{
    if( opval == (address)-1 )
	return( TRUE );

    if( ((LONG)opval & 1 ) != 0 ) {
	ch_lblmod( start , DATLABEL | UNKNOWN | FORCE );
	if( Reason_verbose )
	    eprintf( "\n%06x : AhX(%06x)֕\t" , pre_pc , opval );
	not_program( start , (address)min( (ULONG)pre_pc , (ULONG)limit ) );
	return( FALSE );
    } else if( prolabel( opval ) )
	regist_label( opval , PROLABEL );		/* to increment label count */
    else
	if( !analyze( opval , mode ) && mode != ANALYZE_IGNOREFAULT && !option_i ) {
#ifdef DEBUG
	    if( Debug & BREASON )
		printf( "falseret : %x falseret\n" , pc );
#endif
	    ch_lblmod( start , DATLABEL | UNKNOWN | FORCE );
	    not_program( start , (address)min( (ULONG)pc , (ULONG)limit ) );
	    return( FALSE );
	}
    return( TRUE );
}


/*

  eBuItZbge[uj
  move.w	Label(pc,d0),d0
  jsr		Label(pc,d0)

  Label dc.w	Label1-Label , Label2-Label ,...

  BUG: eBuItZbge[uƔfꍇA
  Ƀe[ũGgo^Ă܂̂ŁAƂ
  not_program ƂĂcĂ܂B( őɂ邱Ƃł͂Ȃ )

*/
private void	pcix( address table , address popval )
{
#ifdef DEBUG
    if( Debug & BDEBUG )
	printf( "pcix : %x %x\n" , table , popval );
#endif

    if( table != popval ) {
	regist_label( table , DATLABEL | UNKNOWN );	/* +3 */
	return;
    }
    relative_table( table );
}


/*

  table 烊eBuItZbge[uƂēo^

*/
extern void	relative_table( address table )
{
    address	tableend;
    address	ptr = table;
    address	label;

    regist_label( table , DATLABEL | RELTABLE );
    tableend = next( table + 1 )->label;
    while( ptr < tableend ) {
	label = table + *(WORD*)( ptr + Ofst );
	if( label < (address)BeginTEXT || label > (address)Last ||
	    ( table <= label && label < ptr + 2 ) ) {
	    regist_label( ptr , DATLABEL | UNKNOWN | FORCE );	/* not rel table */
	    break;
	}
#ifdef DEBUG
	if( Debug & BDEBUG )
	    printf( "lbl %x\n" , label );
#endif
	regist_label( label , DATLABEL | UNKNOWN );
	ptr += 2;
	tableend = next( ptr )->label;
    }
}


/*

  table 烍O[hȃeBuItZbge[uƂēo^

*/
extern void	relative_longtable( address table )
{
    address	tableend;
    address	ptr = table;
    address	label;

    regist_label( table , DATLABEL | RELLONGTABLE );
    tableend = next( table + 1 )->label;
    while( ptr < tableend ) {
	label = table + *(LONG*)( ptr + Ofst );
	if( label < (address)BeginTEXT || label > (address)Last ||
	    ( table <= label && label < ptr + 4 ) ) {
	    regist_label( ptr , DATLABEL | UNKNOWN | FORCE );	/* not rel table */
	    break;
	}
	regist_label( label , DATLABEL | UNKNOWN );
	ptr += 4;
	tableend = next( ptr )->label;
    }
}


#ifdef	OSKDIS
/*

  table 烏[he[uƂēo^

*/
extern void w_table( address table )
{
    address tableend;
    address ptr = table;
    address label;

    regist_label( table , DATLABEL | WTABLE);
    tableend = next( table + 1 )->label;
    while( ptr < tableend ) {
    label = *(WORD*)( ptr + Ofst );
#ifdef DEBUG
    if( Debug & BDEBUG )
	printf( "wlbl %x\n" , label );
#endif
    regist_label( label , DATLABEL | UNKNOWN );
    ptr += 2;
    tableend = next( ptr )->label;
    }
}

#endif	/* OSKDIS */

/*

  table  O[he[uƂēo^

*/
extern void	z_table( address table )
{
    address	tableend;
    address	ptr = table;
    address	label;

    regist_label( table , DATLABEL | ZTABLE );
    tableend = next( table + 1 )->label;
    while( ptr + 4 <= tableend ) {
	label = *(address*)( ptr + Ofst );
	regist_label( label , DATLABEL | UNKNOWN );
#ifdef DEBUG
	if( Debug & BDEBUG )
	    printf( "zlbl %x\n" , label );
#endif
	ptr += 4;
	tableend = next( ptr )->label;
    }
}


/*

  from  to ܂ł̗̈vOŖɂ

*/
extern void	not_program( address from , address to )
{
    address	store;
    address	pcend_save = PCEND;
    address	pc = from;
    disasm	code;

#ifdef DEBUG
    if( Debug & BDEBUG )
	printf( "\nnot_prog %x - %x\n" , from , to );
#endif
    ch_lblmod( from , DATLABEL | UNKNOWN | FORCE );
    store = pc + Ofst;
    PCEND = to;
    while( pc < to ) {
	store += dis( store , &code , &pc );
	unregist_data( &code.op1 );
	unregist_data( &code.op2 );
	unregist_data( &code.op3 );
	unregist_data( &code.op4 );
    }
    PCEND = pcend_save;

#ifdef DEBUG
    if( Debug & BDEBUG )
	printf( "end of not_prog\n" );
#endif
}


/*

   PROLABEL Ƃēo^ς݂ǂׂ

*/
private boolean prolabel( address adrs )
{
    lblbuf	*ptr;

    ptr = search_label( adrs );
    if( ptr != NULL && isPROLABEL( ptr->mode ) )
	return( TRUE );
    return( FALSE );
}


/*

  f[^Ƃēo^

*/
private void	regist_data( disasm *code , operand *op )
{
    if( op->opval != (address)-1 ) {


	if( op->ea == IMMED && code->size2 == LONGSIZE && INPROG( op->opval , op->eaadrs ) )
	    regist_label( op->opval , DATLABEL | UNKNOWN );

	else if( op->ea == PCDISP || op->ea == PCIDX || op->ea == PCIDXB ||
	( op->ea == AbLong && INPROG( op->opval , op->eaadrs ) )||
	( op->ea == AregIDXB && INPROG( op->opval , op->eaadrs ) && op->exbd == 4 ))

	    regist_label( op->opval , DATLABEL | code->size2 );

	else if( op->ea == PCPOSTIDX || op->ea == PCPREIDX ){

	    if( op->exod == 4 && INPROG( op->opval2 , op->eaadrs2 ))
				regist_label( op->opval2 , DATLABEL | code->size2 );

	    if( op->exbd )	regist_label( op->opval	 , DATLABEL | LONGSIZE );
	    else		regist_label( op->opval	 , DATLABEL | code->size2 );

	}else if( op->ea == AregPOSTIDX || op->ea == AregPREIDX ){

	    if( op->exbd == 4 && INPROG( op->opval  , op->eaadrs  ))
		regist_label( op->opval  , DATLABEL | LONGSIZE );

	    if( op->exod == 4 && INPROG( op->opval2 , op->eaadrs2 ))
		regist_label( op->opval2 , DATLABEL | code->size2 );

	}
    }
}


/*

  f[^xƂĂ̓o^

*/
private void	unregist_data( operand *op )
{

    if( op->opval != (address)-1 &&
     (
      op->labelchange1 ||
      (
       (
	op->ea == AbLong ||
	op->ea == IMMED
       ) &&
       INPROG( op->opval , op->eaadrs )
      )
     )
    ){
	unregist_label( op->opval );
    }



    if( op->labelchange2 && INPROG( op->opval2 , op->eaadrs2 ) ){
	unregist_label( op->opval2 );
    }
}


/*

  o^ς݃x̃[hς

*/
extern boolean	ch_lblmod( address pc , lblmode mode )
{
    lblbuf	*ptr;

    ptr = search_label( pc );
    if( regist_label( pc , mode ) ) {
	if( ptr != NULL )
	    unregist_label( pc );
	return( TRUE );
    }

    return( FALSE );
}


/* EOF */
