/*
 *
 *	\[XR[hWFl[^
 *	_lϊW[
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

/* System headers */
#include <stdio.h>	/* sprintf() */

/* Headers */
#include "estruct.h"	/* enum boolean */
#include "hex.h"	/* itox8_without_0supress() */
#include "fpconv.h"


/* External variables */
short	Inreal_flag = FALSE;


/* Functions */
extern void
fpconv_s (char* buf, float* valp)
{
    unsigned short e = *(unsigned short*)valp & 0x7f80;
    unsigned long m = *(unsigned long*)valp & 0x007fffff;

    /* }0.0ɏ */
    if (!Inreal_flag && e == 0 && m == 0) {
	strcpy (buf, (*(char*)valp < 0) ? "0f-0" : "0f0");
	return;
    }

    if (Inreal_flag || e == 0 || e == 0x7f80) {		/* 񐳋K, A */
	*buf++ = '!';					/* ȒlȂ\ŏo */
	itox8_without_0supress (buf, *(long*)valp);
    } else {
	sprintf (buf, "0f%.30g", *valp);
    }
}


/* Functions */
extern void
fpconv_d (char* buf, double* valp)
{
    unsigned short e = *(unsigned short*)valp & 0x7ff0;
    unsigned long mh = *(unsigned long*)valp & 0x000fffff;
    unsigned long ml = *(unsigned long*)valp;

    /* }0.0ɏ */
    if (!Inreal_flag && e == 0 && (mh | ml) == 0) {
	strcpy (buf, (*(char*)valp < 0) ? "0f-0" : "0f0");
	return;
    }

    if (Inreal_flag || e == 0 || e == 0x7ff0) {		/* 񐳋K, A */
	long* p = (long*)valp;				/* ȒlȂ\ŏo */

	*buf++ = '!';
	buf = itox8_without_0supress (buf, *p++);
	*buf++ = '_';
	(void)itox8_without_0supress (buf, *p);
    } else {
	sprintf (buf, "0f%.30g", *valp);
    }
}


#ifdef	NO_LDBL_DOPRNT
/* Functions */
extern void
fpconv_x (char* buf, long double* valp)
{
    unsigned long* p = (unsigned long*)valp;

    *buf++ = '!';
    buf = itox8_without_0supress (buf, *p++);
    *buf++ = '_';
    buf = itox8_without_0supress (buf, *p++);
    *buf++ = '_';
    (void)itox8_without_0supress (buf, *p++);
}
#else
extern void
fpconv_x (char* buf, long double* valp)
{
    unsigned short e = *(unsigned short*)valp & 0x7fff;
    unsigned long mh = ((unsigned long*)valp)[0];
    unsigned long ml = ((unsigned long*)valp)[1];

    /* }0.0ɏ */
    if (!Inreal_flag && e == 0 && (mh | ml) == 0) {
	strcpy (buf, (*(char*)valp < 0) ? "0f-0" : "0f0");
	return;
    }

    if (Inreal_flag || e == 0 || e == 0x7fff		/* 񐳋K, A */
     || ((unsigned short*)valp)[1]			/* gprbgZbg */
     || ((char*)valp)[4] >= 0				/* rbg0 */
#if 1
     || e <= 64						/* CuɈˑ */
#endif
    ) {
	long* p = (long*)valp;				/* ȒlȂ\ŏo */

	*buf++ = '!';
	buf = itox8_without_0supress (buf, *p++);
	*buf++ = '_';
	buf = itox8_without_0supress (buf, *p++);
	*buf++ = '_';
	(void)itox8_without_0supress (buf, *p);
    } else {
	sprintf (buf, "0f%.30Lg", *valp);
    }
}
#endif	/* NO_LDBL_DOPRNT */


/* File scope functions */
static boolean
is_normalized_p (packed_decimal* valp)
{

    if ((valp->ul.hi<<1 | valp->ul.mi | valp->ul.lo) == 0)
	return TRUE;					/* }0.0 */

    if ( ((valp->ul.hi & 0x7fff0000) == 0x7fff0000)	/* , */
      || ((valp->ul.hi & 0x3000fff0) != 0)		/* gprbgZbg */
#if 0
      || ((valp->ul.hi & 0x4fff0000) == 0x4fff0000)	/* 񐳋K */
#endif
      || ((valp->ul.hi & 0x0000000f) > 9) )		/* BCD()̒lُ */
	return FALSE;

    {
	int i;
	unsigned char *ptr = &valp->uc[4];
	for (i = 0; i < 8; i++) {
	    unsigned char c = *ptr++;
	    if ((c > (unsigned char)0x99) || ((c & 0x0f) > (unsigned char)0x09))
		return FALSE;				/* BCD()̒lُ */
	}
    }

   return TRUE;
}


/* Functions */
extern void
fpconv_p (char* buf, packed_decimal* valp)
{

    if (Inreal_flag || !is_normalized_p (valp)) {
	long* p = (long*)valp;				/* ȒlȂ\ŏo */

	*buf++ = '!';
	buf = itox8_without_0supress (buf, *p++);
	*buf++ = '_';
	buf = itox8_without_0supress (buf, *p++);
	*buf++ = '_';
	(void)itox8_without_0supress (buf, *p);

    } else {
	*buf++ = '0';
	*buf++ = 'f';
	if (valp->uc[0] & 0x80)
	    *buf++ = '-';

	/* ̐ */
	*buf++ = '0' + (valp->ul.hi & 0x0000000f);
	*buf++ = '.';

	/* ̏ */
	{
	    int i;
	    unsigned char *ptr = &valp->uc[4];

	    for (i = 0; i < 8; i++) {
		unsigned char c = *ptr++;
		*buf++ = '0' + (c >> 4);
		*buf++ = '0' + (c & 0x0f);
	    }
	}

	/* '0'폜 */
	while (*--buf == (char)'0')
	    ;
	if (*buf != (char)'.')
	    buf++;

	/* w */
	{
	    int expo = (valp->uc[0] & 0x0f)*100
		     + (valp->uc[1] >> 4)*10
		     + (valp->uc[1] & 0x0f);

	    if ((expo == 0) && !(valp->uc[0] & 0x40)) {
		/* "e+0"͏ȗ */
		*buf = '\0';
	    } else {
		*buf++ = 'e';
		*buf++ = (valp->uc[0] & 0x40) ? '-' : '+';
		buf += (expo >= 100) + (expo >= 10) + 1;
		*buf = '\0';
		do {
		    *--buf = '0' + (expo % 10);
		    expo /= 10;
		} while (expo);
	    }
	}
    }
}


/* Functions */
extern void
fpconv_q (char* buf, quadword* valp)
{
    *buf++ = '!';
    buf = itox8_without_0supress (buf, valp->ul.hi);
    *buf++ = '_';
    (void)itox8_without_0supress (buf, valp->ul.lo);
}


/* EOF */
