/* $Id: hex.h,v 1.1 1996/10/24 04:27:46 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	16iϊ , String ֐ wb_
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#ifndef	HEX_H
#define	HEX_H


#include    "global.h"


#define itox8( ptr , num )  itox( ptr , num , 8 )
#define itox4( ptr , num )  itox( ptr , num , 4 )

#define itox8d( ptr , num ) itoxd( ptr , num , 8 )
#define itox4d( ptr , num ) itoxd( ptr , num , 4 )
#define itox2d( ptr , num ) itoxd( ptr , num , 2 )


extern char *itod2( char* , ULONG );	/* 蔲 */
extern char *itox( char* , ULONG , int );
extern char *itox8_without_0supress( char* , ULONG );
extern char *itox6_without_0supress( char* , ULONG );
extern char *itox4_without_0supress( char* , ULONG );

extern char Hex[16];
extern int  Zerosupress_mode;


#ifdef	__GNUC__

inline static char *strend( char *ptr )
{
    while( *ptr++ )
	;
    return --ptr;
}


USEOPTION   option_Z;

inline static char *itox2( char *buf , ULONG num )
{
    if( !option_Z || num >= 0x10 ) {
	*buf++ = Hex[ ( num >> 4 ) & 0xf ];
	*buf++ = Hex[ num & 0xf ];
	*buf = '\0';
	return buf;
    }
    *buf++ = Hex[ num & 0xf ];
    *buf = '\0';
    return buf;
}


inline static char *itox2_without_0supress( char *buf , ULONG num )
{
    *buf++ = Hex[ ( num >> 4 ) & 0xf ];
    *buf++ = Hex[ num & 0xf ];
    *buf = '\0';
    return buf;
}


inline static char *itoxd( char *buf , ULONG num , int width )
{
    if( Zerosupress_mode != 1 || num >= 10 )
	*buf++ = '$';
    return( width == 2 ? itox2( buf , num ) : itox( buf , num , width ) );
}


inline static char *itox6( char *buf , ULONG num )
{
    return itox( buf , num , ( num >= 0x1000000 ? 8 : 6 ) );
}


inline static char *itox6d( char *buf , ULONG num )
{
    if( Zerosupress_mode != 1 || num >= 10 )
	*buf++ = '$';
    return itox6( buf , num );
}

#else

extern char *strend( char* );
extern char *itox2( char* , ULONG );
extern char *itox2_without_0supress( char* , ULONG );
extern char *itoxd( char* , ULONG , int );
extern char *itox6( char* , ULONG );
extern char *itox6d( char* , ULONG );

#endif	/* __GNUC__ */


#endif	/* HEX_H */

/* EOF */
