/* $Id: option.c,v 1.1 1996/11/07 08:03:54 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	Option analyze , etc
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include <stdio.h>
#include <stdlib.h>	/* atoi */
#include <string.h>
#ifdef unix
    #include <unistd.h>
#endif
#ifdef	__LIBC__
    #include <sys/xglob.h>	/* _toslash() */
#endif

#include "disasm.h"
#include "estruct.h"
#include "etc.h"
#include "generate.h"
#include "global.h"
#include "hex.h"
#include "option.h"


#ifndef unix
int	getopt( int , char** , char* );
extern int  optind;
extern char *optarg;
#endif


boolean option_a , option_c , option_d , option_e , option_g , option_h ,
	option_i , option_k , option_l , option_p , option_q , option_r ,
	option_t , option_v , option_x , option_y , option_z , option_B ,
	option_D , option_E , option_I , option_M , option_N , /* option_Q , */
	option_S , option_T , option_U , option_Z;

boolean option_overwrite;


/* main.c */
extern mputypes	MPU_types;
extern short	MMU_type;
extern short	FPCP_type;
extern short	Emulate_mode;	/* bit0=1:fpsp bit1=1:isp emulation߂F */
extern int	String_length_min;
extern char	CommentChar;
extern address	Base , Exec;
extern int	Verbose;
extern int	UndefRegLevel;
extern int	Quiet_mode;

extern char*	Filename_in;
extern char*	Filename_out;
extern char*	Labelfilename_in;
extern char*	Labelfilename_out;
extern char*	Tablefilename;


/* disasm.c */
extern char	FPUID_table[16];	/* bit0͖ bit1,2,30`7̈Ӗ */

/* fpconv.c */
extern short	Inreal_flag;

/* generate.c */
extern int	SymbolColonNum;
extern short	sp_a7_flag;
extern short	Old_syntax;

/* output.c */
extern int	Output_AddressCommentLine;
extern int	Output_SplitByte;

/* symbol.c */
extern int	Symbolbufsize;


/* main.c */
extern void	print_title (void);


/* static ֐vg^Cv */
private void	option_switch (int, char**);



/*

  IvV͂

*/
extern void analyze_args( int argc , char *argv[] )
{
    int fileind;
    char* envptr;

    static const char optionlist[] =
	"a::b:cde::fg::hijklm:n:o:pq::rs:u::vw:xyz:"
	"ABC::DEFIK:L:MNP:QR:S::T::UV:W:XZ::#:-:";

    /* process environment variable `dis_opt' */
    if( /* ( option_Q == FALSE ) && */ ( envptr = getenv( DIS_ENVNAME ) ) ) {
#ifdef USE_STRBPL
	int c;
	char	*ptr;
	char	env[256];
	char	**args;
	int	opts;
	int	count = 1;

	args = alloca( 64 * sizeof( char* ) );
	strncpy( env , envptr , 256 );
	for( ptr = env ; *ptr ; ptr++ )
	    if( *ptr == ' ' ) {
		count++;
		*ptr = '\0';
	    }
	*++ptr = '\0';
	opts = strbpl( args + 1, count + 1 , env ) + 1;
	args[0] = argv[0];  /* fake getopt */

	/* optind = -1; */
	while( ( c = getopt( opts , args , optionlist ) ) != EOF )
	    option_switch( c , args );
#else
	int c;
	int count , cnt;
	char *envs , *envp;	/* envs=Œ, envp=Ɨp */
	char **args , **argp;	/* args=Œ, argp=Ɨp */

	/* Xy[Xŕ */
	while( *envptr == ' ' ) envptr++;
	envp = envs = Malloc( strlen( envptr ) + 1 );
	for( count = 1 ; *envptr ; count++ ) {
	    while( *envptr && (*envptr != ' ') )
		*envp++ = *envptr++;
	    *envp++ = '\0';
	    while( *envptr == ' ' ) envptr++;
	}

	/* eւ̃|C^z */
	argp = args = Malloc( ( count + 1 ) * sizeof( char * ) );
	envp = envs;
	*argp++ = argv[0];		/* my name */
	for( cnt = count ; --cnt ; ) {
	    *argp++ = envp;
	    while( *envp++ ) ;
	}
	*argp = NULL;

	/* IvV */
	/* optind = -1; */
	while( ( c = getopt( count , args , optionlist ) ) != EOF )
	    option_switch( c , args );

	/* Yꂸɉ */
	Mfree( args );
	Mfree( envs );
#endif
    }

    /* process commandline variable */
    {
	int c;
	optind = -1;
	while( ( c = getopt( argc , argv , optionlist ) ) != EOF )
	    option_switch( c , argv );
	fileind = optind;
    }


    while (fileind < argc) {
	if (Filename_in  == NULL)
	    Filename_in  = argv[fileind++];
	else if (Filename_out == NULL)
	    Filename_out = argv[fileind++];
	else
	    err ("t@C܂.\n");
    }
    if ((Filename_in  == NULL) || (*Filename_in  == (char)'\0'))
	usage (1);
    if ((Filename_out == NULL) || (*Filename_out == (char)'\0'))
	Filename_out = "-";


    if ((MMU_type & MMU851) && !(MPU_types & M020))
	err ("-m68851  -m68020 Ƃpł܂.\n");

    if ((FPCP_type & F88x) && !(MPU_types & (M020|M030)))
	err ("-m6888x  -m68020/68030 Ƃpł܂.\n");

    if ((Emulate_mode & 2) && (MPU_types & M060))
	MPU_types |= MISP;

    if( Emulate_mode & 1 ) {
	short tmp = FPCP_type;
	if( tmp & F040 ) tmp |= F4SP;
	if( tmp & F060 ) tmp |= F6SP;
	FPCP_type = tmp;
    }


    /* if invoked with -T , labelfile must be read */
    if( option_T )
	option_g = TRUE;


    /* xt@C/e[ut@C쐬 */
    {
	char* file = strcmp ("-", Filename_out) ? Filename_out : "aout";
	char* buf = Malloc (strlen (file) + 1);
	size_t len;

	strcpy (buf, file);
#ifdef	__LIBC__
	(void) _toslash (buf);
#endif

	{
	    char* p = strrchr (buf, '/');
	    p = p ? (p + 1) : buf;
	    p = strrchr ((*p == (char)'.') ? (p + 1) : p, '.');
	    if (p)
		*p = '\0';		/* gq폜 */
	}
	len = strlen (buf) + 4 + 1;

	if (option_g && Labelfilename_in == NULL) {
	    Labelfilename_in = Malloc (len);
	    strcat (strcpy (Labelfilename_in, buf), ".lab");
	}
	if (option_e && Labelfilename_out == NULL) {
	    Labelfilename_out = Malloc (len);
	    strcat (strcpy (Labelfilename_out, buf), ".lab");
	}
	if (option_T && Tablefilename == NULL) {
	    Tablefilename = Malloc (len);
	    strcat (strcpy (Tablefilename, buf), ".tab");
	}

	Mfree (buf);
    }
}


private int	ck_atoi (char *str)
{
    char *ptr , c;

    for (ptr = str ; (c = *ptr++) != '\0' ;) {
	if ((c < '0') || ('9' < c))
	    err ("l̎w肪ُł.\n");
    }

    return atoi (str);
}


private void
init_fpuid_table (void)
{
    memset (FPUID_table, 0, sizeof FPUID_table);
}


private void	option_switch( int opt , char **argv )
{
    switch( opt ) {
    case 'a':
	option_a = TRUE;
	Output_AddressCommentLine = ( optarg ? ck_atoi (optarg) : 5 );
	break;
    case 'b':
	Generate_SizeMode = ck_atoi (optarg);
	break;
    case 'c':
	option_c = TRUE;
	break;
    case 'd':
	option_d = TRUE;
	break;
    case 'e':
	option_e = TRUE;
	if (optarg)
	    Labelfilename_out = optarg;
	break;
    case 'f':
	Disasm_Exact = FALSE;
	break;
    case 'g':
	option_g = TRUE;
	if (optarg)
	    Labelfilename_in = optarg;
	break;
    case 'h':
	option_h = TRUE;
	break;
    case 'i':
	option_i = TRUE;
	break;
    case 'j':
	Disasm_AddressErrorUndefined = FALSE;
	break;
    case 'k':
	option_k = TRUE;
	break;
    case 'l':
	option_l = TRUE;
	break;
    case 'm':
	{
	    int init = 1;
#ifndef	__LIBC__
	    char* new_optarg = (char*) Malloc (strlen (optarg) + 1);
	    optarg = strcpy (new_optarg, optarg);
#endif
	    do {
		int m;
		char* p = strchr (optarg, ',');

		if (p) *p++ = '\0';
		m = (strcmp (optarg, "680x0") == 0) ? -1 : ck_atoi (optarg);

		if (m == 68851) {
		    MMU_type |= MMU851;
		    break;
		}

		if (m == 68881 || m == 68882) {
		    int id = p ? ck_atoi (p) : 1;

		    FPCP_type |= (m == 68882) ? F882 : F881;
		    if (id & ~7)
			err ("FPU ID̒lُł(-m).\n");
		    FPUID_table[id*2] = 1;
		    break;
		}

		else {
		    if (init) {
			init = 0;
			MPU_types = 0;
			FPCP_type = MMU_type = 0;
			init_fpuid_table ();
		    }
		    switch (m) {
		    case 68000:
			MPU_types |= M000;
			break;
		    case 68010:
			MPU_types |= M010;
			break;
		    case 68020:
			MPU_types |= M020;
			break;
		    case 68030:
			MPU_types |= M030;
			MMU_type |= MMU030;
			break;
		    case 68040:
			MPU_types |= M040;
			FPCP_type |= F040;
			MMU_type |= MMU040;
			FPUID_table[1*2] = 1;
			break;
		    case 68060:
			MPU_types |= M060;
			FPCP_type |= F060;
			MMU_type |= MMU060;
			FPUID_table[1*2] = 1;
			break;
		    case -1:	/* -m680x0 */
			MPU_types |= (M000|M010|M020|M030|M040|M060);
			FPCP_type |= (F040|F060);
			MMU_type |= (MMU030|MMU040|MMU060);
			FPUID_table[1*2] = 1;
			break;
		    default:
			err ("w MPU, FPU ̓T|[gĂ܂(-m).\n");
		    }
		}
		optarg = p;
	    } while (optarg);
#ifndef	__LIBC__
	    Mfree (optarg);
#endif
	}
	break;
    case 'n':
	String_length_min = ck_atoi (optarg);
	break;
    case 'o':
	String_width = ck_atoi (optarg);
	if( String_width < 1 || 80 < String_width )
	    err ("lȔ͈͂ł(-o).\n");
	break;
    case 'p':
	option_p = TRUE;
	break;
    case 'q':
	option_q = TRUE;
	if( optarg ) Quiet_mode = ck_atoi (optarg);
	if( Quiet_mode < 0 || 1 < Quiet_mode )
	    err ("lȔ͈͂ł(-q).\n");
	break;
    case 'r':
	option_r = TRUE;
	break;
    case 's':
	Symbolbufsize = ck_atoi (optarg) + 1;
	break;
/*
    case 't':
	option_t = TRUE;
	break;
*/
    case 'u':
	Disasm_UnusedTrapUndefined = FALSE;
	if (optarg && (ck_atoi (optarg) == 1))
	    Disasm_SX_Window = TRUE;
	break;
    case 'v':
	option_v = TRUE;
	break;
    case 'w':
	Data_width = ck_atoi (optarg);
	if( Data_width < 1 || 32 < Data_width )
	    err ("lȔ͈͂ł(-w).\n");
	break;
    case 'x':
	option_x = TRUE;
	break;
    case 'y':
	option_y = TRUE;
	break;
    case 'z':
	option_z = TRUE;
	Absolute = ABSOLUTE_ZOPT;
	{
	    char *p;
	    if ((p = strchr (optarg , ',')) != NULL) {
		*p++ = '\0';
		Base = (address)atox( optarg );
		Exec = (address)atox( p );
	    } else {
		Base = (address)atox( optarg );
		Exec = Base;
	    }
	}
	if( Base > Exec ){
	    err ("lȔ͈͂ł(-z).\n");
	}
	break;

    case 'A':
	Disasm_MnemonicAbbreviation = TRUE;
	break;
    case 'B':
	option_B = TRUE;
	break;
    case 'C':
	SymbolColonNum = optarg ? ck_atoi (optarg) : 0;
	if( SymbolColonNum < 0 || 3 < SymbolColonNum )
	    err ("lȔ͈͂ł(-C).\n");
	break;
    case 'D':
	option_D = TRUE;
	break;
    case 'E':
	option_E = TRUE;
	break;
    case 'F':
	Disasm_Dbra = FALSE;
	break;
    case 'I':
	option_I = TRUE;
	break;
    case 'K':
	if (!optarg[0] || optarg[1])
	    err ("RgLN^͈ꕶwo܂(-K).\n");
	CommentChar = *optarg;
	break;
    case 'L':
	if (!optarg[0] || optarg[1])
	    err ("x̐擪͈ꕶwo܂(-L).\n");
	if ((char)'0' <= *optarg && *optarg <= (char)'9')
	    err ("x̐擪ɐ͎g܂(-L).\n");
	Label_first_char = *optarg;
	break;
    case 'M':
	option_M = TRUE;
	break;
    case 'N':
	option_N = TRUE;
	break;
    case 'P':
	Emulate_mode = ck_atoi (optarg);
	if (Emulate_mode & ~0x03)
	    err ("lȔ͈͂ł(-P).\n");
	break;
    case 'Q':
    /*  option_Q = TRUE;  */
	break;
    case 'R':
	UndefRegLevel = ck_atoi (optarg);
	if (UndefRegLevel & ~0x0f)
	    err ("lȔ͈͂ł(-R).\n");
	break;
    case 'S':
	option_S = TRUE;
	Output_SplitByte = ( optarg ? ck_atoi (optarg) : 64 ) * 1024;
	break;
    case 'T':
	option_T = TRUE;
	if (optarg)
	    Tablefilename = optarg;
	break;
    case 'U':
	option_U = TRUE;
	strupr (opsize);
	/* fall through */
    case 'X':
	strupr( Hex );
	break;
    case 'V':
	Verbose = ck_atoi (optarg);
	if( Verbose < 0 || 2 < Verbose )
	    err ("lȔ͈͂ł(-V).\n");
	break;
    case 'W':
	Compress_len = ck_atoi (optarg);
	break;
    case 'Z':
	option_Z = TRUE;
	Zerosupress_mode = optarg ? ck_atoi(optarg) : 0;
	if( Zerosupress_mode < 0 || 1 < Zerosupress_mode )
	    err ("lȔ͈͂ł(-Z).\n");
	break;
    case '#':
	Debug = ck_atoi (optarg);
	break;
    case '-':
	{
#define isLONGOPT(str) (strcmp( optarg , str ) == 0)

	         if (isLONGOPT(    "fpsp" ))	Emulate_mode |=  1;
	    else if (isLONGOPT( "no-fpsp" ))	Emulate_mode &= ~1;
	    else if (isLONGOPT(    "isp" ))	Emulate_mode |=  2;
	    else if (isLONGOPT( "no-isp" ))	Emulate_mode &= ~2;
	    else if (isLONGOPT( "no-fpu" ))	{ FPCP_type = 0; init_fpuid_table (); }
	    else if (isLONGOPT( "no-mmu" ))	MMU_type = 0;

	    else if (isLONGOPT( "sp" ))		sp_a7_flag = TRUE;
	    else if (isLONGOPT( "a7" ))		sp_a7_flag = FALSE;
	    else if (isLONGOPT( "old-syntax" ))	Old_syntax = TRUE;
	    else if (isLONGOPT( "new-syntax" ))	Old_syntax = FALSE;
	    else if (isLONGOPT( "inreal" ))	Inreal_flag = TRUE;
	    else if (isLONGOPT( "real" ))	Inreal_flag = FALSE;

	    else if (isLONGOPT( "overwrite" ))	option_overwrite = TRUE;
	    else if (isLONGOPT( "help" ))	usage( 0 );
	    else if (isLONGOPT( "version" )) {	printf( "dis version %s\n" , Version );
						exit( 0 ); }
	    else
		err ("%s: unrecognized option '--%s'\n", argv[0], optarg);
	}
	break;
/*  case '?':  */
    default:
	exit (EXIT_FAILURE);
	break;
    }
    return;
}


extern void
usage (int exitcode)
{
    static const char message[] =
	"usage: dis [option] st@C [o̓t@C]\n"
	"option:\n"

	/* IvV */
	"	-a[num]		numsƂɃAhXRgœ(num ȗ5s)\n"
	"	-b num		Ε򖽗߂̃TCY̏o(0: 1:ɏȗ 2:ɕt)\n"
	"	-c		x`FbNsȂ\n"
	"	-d		foCXhCo̎Ɏw\n"
	"	-e[file]	xt@C̏o\n"
	"	-f		oCg얽߂̕soCg̃`FbN($00 or $ff ?)Ȃ\n"
	"	-g[file]	xt@Cǂݍ\n"
	"	-h		f[^̈撆$4e75(rts)̎̃AhXɒڂ\n"
	"	-i		Ŗ`߂Ăf[^̈ƌȂȂ\n"
	"	-j		AhXG[Nł낤߂𖢒`߂ƌȂȂ\n"
	"	-k		߂̒wx͂Ȃ̂ƌȂ\n"
	"	-l		vÖ悪ȂȂ܂ŉx{ƂȂ\n"
	"	-m 680x0	tAZuΏۂMPUw(x=[0],1-4,6)\n"
	"	-m 68851	68851߂Lɂ(-m68020 w莞̂ݗL)\n"
	"	-m 6888x[,ID]	LFPCPƂIDw(68881/68882 ID=0-7,ȗ1)\n"
	"	-n num		ƂĔ肷ŏ̒. 0Ȃ画肵Ȃ(l=3)\n"
	"	-o num		̈̉oCg(1num80 l=70)\n"
	"	-p		f[^̈撆̃vÖ𔻕ʂȂ\n"
	"	-q[num]		bZ[Wo͂Ȃ([0]:ʏ 1:e[uɊւo͂Ȃ)\n"
	"	-r		16ĩRgt\n"
	"	-s num		V{obt@̐w(l=1024)\n"
/*	"	-t		AhXe[u̎ʂsȂ\n" */
	"	-u[num]		gpA,F line trap𖢒`߂ƌȂȂ(num=1 SX-WindowΉ)\n"
	"	-v		PȂtAZuXg̏o\n"
	"	-w num		f[^̈̉oCg(1num32 l=8)\n"
	"	-x		ۂ̃IyR[h16ĩRgŕt\n"
	"	-y		SẴf[^̈vÖłȂm߂邱ƂȂ\n"
	"	-z base,exec	st@CbasẽoCit@CƂ݂ȂAexec͂\n"

	/* 啶IvV */
	"\n"
	"	-A		cmpi, movea  cmp, move ɂ\n"
	"	-B		bra ̌łs\n"
	"	-C[num]		x̌̃R(0:tȂ 1:SĂ1 [2]:ʏ 3:SĂ2)\n"
	"	-D		f[^ZNVɂvOF߂\n"
	"	-E		oCg얽߂̕soCg̏`FbNȂ\n"
	"	-F		dbra, fdbra  dbf, fdbf Ƃďo͂\n"


	"	-I		߂̒x̃AhX\\n"

	"	-K char		char RgLN^Ƃėp\n"
	"	-L char		char x̐擪Ƃėp\n"
	"	-M		cmpi, move, addi.b, subi.b #imm  pack, unpk ɃRg\n"
	"	-N		TCYftHgȂtȂ\n"

	"	-P num		\tgEFAG~[V߂Lɂ(rbgw, l=3)\n"
	"		+1	_߂Lɂ\n"
	"		+2	߂Lɂ\n"
   /*	"	-Q		ϐ dis_opt QƂȂ\n"   */
	"	-R num		gptB[h̃`FbNڂ̎w(rbgw, l=15)\n"
	"		+1	mulu.l, muls.l, ftst.x ɂ関gpWX^tB[h̃`FbN\n"
	"		+2	gAhbVOł̃TvXꂽWX^tB[h̃`FbN\n"
	"		+4	TvXꂽCfbNXWX^ɑ΂XP[Õ`FbN\n"
	"		+8	TvXꂽCfbNXWX^ɑ΂TCYw(.l)̃`FbN\n"
	"	-S[num]		o̓t@C num Kbyte Ƃɕ(num ȗ 64Kbyte)\n"
	"	-T[file]	e[uLqt@Cǂݍ\n"
	"	-U		j[jbN啶ŏo͂\n"
	"	-V num		obNgbŇ̕\(0:Ȃ [1]:vÖ 2:SĂ̗̈)\n"
	"	-W num		f[^ .dcb ŏo͂ŏoCg. 0Ȃ爳kȂ(l=64)\n"
	"	-X		16i啶ŏo͂\n"

	"	-Z[num]		16i[TvX([0]:ʏ 1:ȗ\'$'ȗ)\n"

	/* PꖼIvV */
	"\n"
	"	--(no-)fpsp	_߂[L]()ɂ\n"
	"	--(no-)isp	߂[L]()ɂ\n" 
	"	--no-fpu	FPU߂𖳌ɂ(-m68040`68060̌Ɏw)\n" 
	"	--no-mmu	MMU߂𖳌ɂ(-m68030`68060̌Ɏw)\n" 
	"	--sp		a7WX^'sp'ƕ\L(Wł--a7)\n"
	"	--old-syntax	AhbVO\Lŏo͂(Wł--new-syntax)\n"
	"	--(in)real	_[\L](\)ŏo͂\n"
	"	--overwrite	t@C𖳏ŏ㏑\n"
	"	--version	o[W\\n"
	"	--help		gp@\\n"

#if 0	/* BIvV */
	"\n"
	"	-# num		fobO[h\n"
#endif
	; /* end of message */

    print_title();
    eprintf (message);
    exit (exitcode);
}

/* EOF */
